#pragma once

#include <stddef.h>
#include <stddef.h>
#include <stdbool.h>

enum lkt_uri_type {
    uri_id,
    uri_playlist,
    uri_type,
    uri_author,
    uri_category,
    uri_language,
    uri_query,
};

struct lkt_uri {
    enum lkt_uri_type type;
    const char *column_name;
    union {
        void *value;
        size_t id;
    };
    bool _allocated;
    bool is_int;
};

/* Create and delete URIs */
bool lkt_uri_from(struct lkt_uri *ret, char *const str);
bool lkt_uri_from_list(struct lkt_uri *ret, char **list);
void lkt_uri_free(struct lkt_uri *ret);

/* Make an URL to download from kurisu.
   base_url is the prefix for the api, e.g. https://kurisu.iiens.net/api_kara.php */
int lkt_uri_to_url(struct lkt_uri *uri, const char *base_url, char *ret, size_t len);
