#!/bin/sh

# $0: script name
# $1: input
# $2: output
# $3: header
# $4: footer
[ $# -ne 4 ] && exit 1
[ "$1" == "$2" ] && exit 2

# Global variables
HEADER="$3"
FOOTER="$4"
INPUT="$1"
OUTPUT="$2"

# Functions
function the_day() {
    # $1: file
    # $2: what to replace with the date
    local DATE=$(date +'%B %d, %Y')
    sed -i "s/$2/$DATE/g" "$1"
}

function the_page() {
    # $1: file
    # $2: what to replace with the date
    FILE=$(basename "$1")
    FILE="${FILE%.*}"
    FILE="${FILE^^}"
    sed -i "s/$2/$FILE/g" "$1"
}

function mk_manpage() {
    # $1: input
    # $2: output
    cat $HEADER > $2
    cat $1 >> $2
    cat $FOOTER >> $2
    the_day "$2" '___DATE___'
    the_page "$2" '___PAGE___'
}

mk_manpage "$INPUT" "$OUTPUT"
exit 0
